#ifndef RUSCODER_H__
#define RUSCODER_H__

typedef struct {                        /*  ४஢                 */
    short int  rating;
    char   name[7];
    char * tbl;
} code_;

typedef struct {
    int cnt;
    char  c;
} Freq_;

/*
 * ஢
 */
typedef enum coding_
    { check = -1, dos = 0, koi = 1, win = 2, iso = 3, mac = 4} coding;

/*
 * functions forwards
 */
void   rating       (int);                         /*  ३⨭                      */
int    compRating   (const void *, const void *);  /* ஢ ३⨭                    */
char * makeCodeTable(const char *, char * );       /*  ⠡ ४஢   */
int    compFreq     (const void *, const void *);  /* ஢                        */
int    compName     (const void *, const void *);  /* ஢ ஢             */
void   makeTables   (void);                        /* 樠                               */
void   help         (void);                        /*   ᯮ짮             */
void   ver          (void);                        /*                            */
void   url          (void);                        /*  ᪠ ணࠬ                    */
void   parseArgs    (int, char * []);              /*   ப                 */
void   outDecode    (char *, char *);              /* 뢮 १                        */

void   openSrc      ();
void   openDest     ();
int    getNextChar  ();                            /* 祭 । ᨬ            */
void   ungetChar    (int);
void   putNextChar  (int);                         /* 뢮 । ᨬ                */
void   closeDest    ();


extern char *  Version;
extern int     CodeCount;     /* ᨬ쭮 - ਠ⮢ ஢    */
extern int     TryCount;      /* 쭮 ᯮ짮 -              */
extern code_ * Cod;
extern int     CODES;
extern coding  from;          /* 㤠 ४஢                      */
extern coding  to;            /*   ४஢                      */
extern int     quote;         /* ஢  quoted-printable           */
extern char    qchar;         /*    ᨬ 砫              */
extern int     allVer;        /* 뢥  ਠ ஢           */
extern int     useClip;       /* 室  室 -  Clipboard                */
extern char *  stdstr;        /*   ப                     */
extern char *  frqstr;        /* ࠧ                              */
extern FILE *  in;            /* 㤠                               */
extern FILE *  out;           /* 㤠                                 */
extern char *  infile;        /*  室 䠩                         */
extern char *  outfile;       /*  室 䠩                        */
extern FILE *  t;             /* ६ 䠩                             */
extern char *  trans;
extern Freq_   Freq[128];     /* ⨪                           */
extern char    buf[129];      /*   ६ ⠡ ४஢   */
extern char *  tocodes[5];    /*   ४஢ (dkwim)       */
extern char *  basecodes[5];  /*   ⠡  ४஢ */
extern char *  basenames[];   /*  ஢                            */


#endif  /* RUSCODER_H__ */

